searchNodes=[{"doc":"High level wrapper for the chrome debug protocol and managing headless chrome browsers.","ref":"SpeedTest.html","title":"SpeedTest","type":"module"},{"doc":"Returns a single attribute for a node Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, input} = page |&gt; SpeedTest.get(&quot;input&quot;) iex&gt; page |&gt; SpeedTest.attribute(input, &quot;name&quot;) {:ok, &quot;test&quot;}","ref":"SpeedTest.html#attribute/4","title":"SpeedTest.attribute/4","type":"function"},{"doc":"Returns all attributes for a dom node as a map Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, input} = page |&gt; SpeedTest.get(&quot;input&quot;) iex&gt; page |&gt; SpeedTest.attributes(input) {:ok, %{&quot;type&quot; =&gt; &quot;email&quot;, &quot;data-test&quot; =&gt; &quot;login_email&quot;, &quot;name&quot; =&gt; &quot;test&quot;}}","ref":"SpeedTest.html#attributes/3","title":"SpeedTest.attributes/3","type":"function"},{"doc":"Clears a text input. Wrapper fro calling click on an input 3 times and typing backspace. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, email_input} = page |&gt; SpeedTest.get(&quot;[data-test=login_email]&quot;) iex&gt; :ok = page |&gt; SpeedTest.type(email_input, &quot;testing@test.com&quot;) iex&gt; page |&gt; SpeedTest.value(email_input) {:ok, &quot;testing@test.com&quot;} iex&gt; page |&gt; SpeedTest.clear(email_input) :ok iex&gt; page |&gt; SpeedTest.value(email_input) {:ok, &quot;&quot;}","ref":"SpeedTest.html#clear/3","title":"SpeedTest.clear/3","type":"function"},{"doc":"Clicks on a dom node. Can take in a params object with the number of times to click. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, button} = page |&gt; SpeedTest.get(&quot;button&quot;) iex&gt; page |&gt; SpeedTest.click(button) :ok iex&gt; page |&gt; SpeedTest.click(button, %{click_count: 2}) :ok","ref":"SpeedTest.html#click/4","title":"SpeedTest.click/4","type":"function"},{"doc":"Closes a page process. Note this does NOT stop the underlying chroxy chrome process Examples iex&gt; page = SpeedTest.launch() iex&gt; SpeedTest.close(page) true","ref":"SpeedTest.html#close/1","title":"SpeedTest.close/1","type":"function"},{"doc":"Returns the current URL Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; page |&gt; SpeedTest.current_url() &quot;http://localhost:8081/&quot;","ref":"SpeedTest.html#current_url/2","title":"SpeedTest.current_url/2","type":"function"},{"doc":"Changes the dimensions of a given page Examples iex&gt; page = SpeedTest.launch() iex&gt; page |&gt; SpeedTest.dimensions(%{width: 1920, height: 1080}) :ok","ref":"SpeedTest.html#dimensions/3","title":"SpeedTest.dimensions/3","type":"function"},{"doc":"Focuses on a given node. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, id} = page |&gt; SpeedTest.get(&quot;input&quot;) iex&gt; page |&gt; SpeedTest.focus(id) :ok","ref":"SpeedTest.html#focus/3","title":"SpeedTest.focus/3","type":"function"},{"doc":"Gets a node_id/0 to a given selector on the page. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, id} = page |&gt; SpeedTest.get(&quot;input&quot;) iex&gt; is_integer(id) true iex&gt; {:ok, id} = page |&gt; SpeedTest.get(&quot;[data-test=login_email]&quot;) iex&gt; is_integer(id) true","ref":"SpeedTest.html#get/3","title":"SpeedTest.get/3","type":"function"},{"doc":"Gets a cookie from the page Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; page |&gt; SpeedTest.set_cookie(%SpeedTest.Cookie{domain: &quot;localhost&quot;, name: &quot;testing&quot;, value: &quot;123&quot;}) :ok iex&gt; page |&gt; SpeedTest.get_cookie(&quot;testing&quot;) %SpeedTest.Cookie{domain: &quot;localhost&quot;, name: &quot;testing&quot;, value: &quot;123&quot;}","ref":"SpeedTest.html#get_cookie/3","title":"SpeedTest.get_cookie/3","type":"function"},{"doc":"Navigates to a given URL. This URL can be shorted by providing the configuration value :base_url i.e. config :speed_test, base_url: &quot;http://localhost:4003&quot; Examples iex&gt; page = SpeedTest.launch() iex&gt; page |&gt; SpeedTest.goto(&quot;/&quot;) :ok","ref":"SpeedTest.html#goto/3","title":"SpeedTest.goto/3","type":"function"},{"doc":"Waits for a given network request to happen. Can be anything that shows up in the network tab from XHR request to CSS to javascript. NOTE you do not want to use this on the home page since the goto() function already waits for page load and will not record that HTTP request. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, %{&quot;request&quot; =&gt; %{&quot;url&quot; =&gt; &quot;http://localhost:8081/app.js&quot;}, &quot;response&quot; =&gt; %{&quot;status&quot; =&gt; 200}}} = page |&gt; SpeedTest.intercept_request(&quot;GET&quot;, &quot;/app.js&quot;)","ref":"SpeedTest.html#intercept_request/4","title":"SpeedTest.intercept_request/4","type":"function"},{"doc":"Launch creates a new browser session inside headless chrome. Examples iex&gt; page = SpeedTest.launch() iex&gt; is_pid(page) true","ref":"SpeedTest.html#launch/1","title":"SpeedTest.launch/1","type":"function"},{"doc":"Creates a PDF from the current page. Optionally can be saved to a provided path. Parameters scale = 1, displayHeaderFooter = false, headerTemplate = &#39;&#39;, footerTemplate = &#39;&#39;, printBackground = false, landscape = false, pageRanges = &#39;&#39;, preferCSSPageSize = false, margin = {}, path = null Examples iex&gt; page = SpeedTest.launch() iex&gt; page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, pdf} = page |&gt; SpeedTest.pdf(&quot;/&quot;) iex&gt; is_binary(pdf) and String.length(pdf) &gt; 0 true","ref":"SpeedTest.html#pdf/3","title":"SpeedTest.pdf/3","type":"function"},{"doc":"Gets arbitrary properties from a dom node. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, email_input} = page |&gt; SpeedTest.get(&quot;[data-test=login_email]&quot;) iex&gt; page |&gt; SpeedTest.property(email_input, &quot;type&quot;) {:ok, &quot;email&quot;}","ref":"SpeedTest.html#property/4","title":"SpeedTest.property/4","type":"function"},{"doc":"Captures a screenshot of the current window. Optionally saves the output to a given path Examples iex&gt; page = SpeedTest.launch() iex&gt; page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, png} = page |&gt; SpeedTest.screenshot(&quot;/&quot;) iex&gt; is_binary(png) and String.length(png) &gt; 0 true","ref":"SpeedTest.html#screenshot/3","title":"SpeedTest.screenshot/3","type":"function"},{"doc":"Sets a cookie on the page. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; page |&gt; SpeedTest.set_cookie(%SpeedTest.Cookie{domain: &quot;localhost&quot;, name: &quot;testing&quot;, value: &quot;123&quot;}) :ok","ref":"SpeedTest.html#set_cookie/3","title":"SpeedTest.set_cookie/3","type":"function"},{"doc":"Utility function for returning the text of a DOM node (&quot;textContent&quot; property) Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, header} = page |&gt; SpeedTest.get(&quot;h1&quot;) iex&gt; page |&gt; SpeedTest.text(header) {:ok, &quot;I am a website&quot;}","ref":"SpeedTest.html#text/3","title":"SpeedTest.text/3","type":"function"},{"doc":"Types text in a given node. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, email_input} = page |&gt; SpeedTest.get(&quot;[data-test=login_email]&quot;) iex&gt; :ok = page |&gt; SpeedTest.type(email_input, &quot;testing@test.com&quot;) iex&gt; page |&gt; SpeedTest.value(email_input) {:ok, &quot;testing@test.com&quot;}","ref":"SpeedTest.html#type/4","title":"SpeedTest.type/4","type":"function"},{"doc":"Gets the &quot;value&quot; property from a given node. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; {:ok, email_input} = page |&gt; SpeedTest.get(&quot;[data-test=login_email]&quot;) iex&gt; page |&gt; SpeedTest.value(email_input) {:ok, &quot;&quot;}","ref":"SpeedTest.html#value/3","title":"SpeedTest.value/3","type":"function"},{"doc":"Waits for the current URL to equal the provided one. Useful if you have a redirect that occurs after some user action. Examples iex&gt; page = SpeedTest.launch() iex&gt; :ok = page |&gt; SpeedTest.goto(&quot;/&quot;) iex&gt; :ok = page |&gt; SpeedTest.wait_for_url(&quot;/&quot;, retry: %SpeedTest.Retry{timeout: :timer.seconds(2)}) :ok","ref":"SpeedTest.html#wait_for_url/3","title":"SpeedTest.wait_for_url/3","type":"function"},{"doc":"","ref":"SpeedTest.html#t:node_id/0","title":"SpeedTest.node_id/0","type":"type"},{"doc":"","ref":"SpeedTest.html#t:options/0","title":"SpeedTest.options/0","type":"type"},{"doc":"Struct that represents HTTP cookies Examples iex&gt; %SpeedTest.Cookie{domain: &quot;localhost&quot;, name: &quot;testing&quot;, value: &quot;123&quot;}","ref":"SpeedTest.Cookie.html","title":"SpeedTest.Cookie","type":"module"},{"doc":"Registry that contains state on running pages.","ref":"SpeedTest.Page.Registry.html","title":"SpeedTest.Page.Registry","type":"module"},{"doc":"Looks up a given page and returns the associated process.","ref":"SpeedTest.Page.Registry.html#lookup/1","title":"SpeedTest.Page.Registry.lookup/1","type":"function"},{"doc":"Given a page with an id, will register the current process under that id.","ref":"SpeedTest.Page.Registry.html#register/1","title":"SpeedTest.Page.Registry.register/1","type":"function"},{"doc":"Manages individual browser pages","ref":"SpeedTest.Page.Session.html","title":"SpeedTest.Page.Session","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"SpeedTest.Page.Session.html#child_spec/1","title":"SpeedTest.Page.Session.child_spec/1","type":"function"},{"doc":"width integer Overriding width value in pixels (minimum 0, maximum 10000000). 0 disables the override. height integer Overriding height value in pixels (minimum 0, maximum 10000000). 0 disables the override. deviceScaleFactor number Overriding device scale factor value. 0 disables the override. mobile boolean Whether to emulate mobile device. This includes viewport meta tag, overlay scrollbars, text autosizing and more. screenOrientation ScreenOrientation Screen orientation override.","ref":"SpeedTest.Page.Session.html#handle_call/3","title":"SpeedTest.Page.Session.handle_call/3","type":"function"},{"doc":"","ref":"SpeedTest.Page.Session.html#start_link/2","title":"SpeedTest.Page.Session.start_link/2","type":"function"},{"doc":"A supervisor for all the page sessions so we can dynamically spin them up.","ref":"SpeedTest.Page.Supervisor.html","title":"SpeedTest.Page.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"SpeedTest.Page.Supervisor.html#child_spec/1","title":"SpeedTest.Page.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"SpeedTest.Page.Supervisor.html#start_child/2","title":"SpeedTest.Page.Supervisor.start_child/2","type":"function"},{"doc":"","ref":"SpeedTest.Page.Supervisor.html#start_link/1","title":"SpeedTest.Page.Supervisor.start_link/1","type":"function"},{"doc":"Wrapper around retries and calculating how many retries to run. Examples iex&gt; %SpeedTest.Retry{timeout: :timer.seconds(2)} iex&gt; %SpeedTest.Retry{timeout: :timer.seconds(10), interval: :timer.seconds(1)}","ref":"SpeedTest.Retry.html","title":"SpeedTest.Retry","type":"module"},{"doc":"Calculates the max number of interations to execute the retry on.","ref":"SpeedTest.Retry.html#calc_max/1","title":"SpeedTest.Retry.calc_max/1","type":"function"},{"doc":"A mock server for running tests against","ref":"Test.Support.MockServer.html","title":"Test.Support.MockServer","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Test.Support.MockServer.html#call/2","title":"Test.Support.MockServer.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Test.Support.MockServer.html#init/1","title":"Test.Support.MockServer.init/1","type":"function"},{"doc":"SpeedTest An integration testing framework focused on concurrency.","ref":"readme.html","title":"SpeedTest","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding speed_test to your list of dependencies in mix.exs: def deps do [ {:speed_test, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/speed_test. TODO Done? | Name :---:| --- ✅| Navigation ✅| Element Selection ✅| Focus ✅| Input ✅| Input Values ✅| Screenshots ✅| PDFs ✅| Attributes ✅| Clicking ✅| URL ✅| Cookies ⬜️| Runtime Evaluation ✅| Request Interception","ref":"readme.html#installation","title":"SpeedTest - Installation","type":"extras"},{"doc":"SPEED_TEST_MOCKS=true mix test To run the speed test unit tests","ref":"readme.html#tests","title":"SpeedTest - Tests","type":"extras"},{"doc":"Usage","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"Add speed_test to your mix.exs def deps do [ {:speed_test, &quot;~&gt; 0.1.0&quot;} ] end Ensure that chrome is installed and available on the path. Docker If using docker you will need to install the necessary dependencies. The below config runs speed tests with docker and alpine: FROM alpine:edge # Installs latest Chromium (77) package. RUN apk add --no-cache \\ chromium \\ nss \\ freetype \\ freetype-dev \\ harfbuzz \\ ca-certificates \\ ttf-freefont RUN addgroup -S spduser &amp;&amp; adduser -S -g spduser spduser \\ &amp;&amp; mkdir -p /home/spduser/Downloads /app \\ &amp;&amp; chown -R spduser:spduser /home/spduser \\ &amp;&amp; chown -R spduser:spduser /app # Run everything after as non-privileged user. USER spduser Note: You will need to configure the chromium path to &#39;/usr/bin/chromium-browser&#39; in the chroxy settings","ref":"usage.html#installation","title":"Usage - Installation","type":"extras"},{"doc":"When setting up a project the recommended way is to initialize a poncho app inside your main app (NOT umbrella). To do this inside an application: mix new e2e Add parent app to mix.exs: {:my_app, path: &quot;../&quot;}, Add speed_test to mix.exs: {:speed_test, &quot;~&gt; 0.1.0&quot;} Import parent app config in config.exs import_config &quot;../../config/config.exs&quot; Alternatively you could add speed_test as a dependency to your main application and configure it there along with tests.","ref":"usage.html#project-setup","title":"Usage - Project Setup","type":"extras"},{"doc":"Chroxy First you&#39;ll need to configure chroxy, the thing that manages your chrome headless sessions. config :chroxy, chrome_remote_debug_port_from: System.get_env(&quot;CHROXY_CHROME_PORT_FROM&quot;) || &quot;9222&quot;, chrome_remote_debug_port_to: System.get_env(&quot;CHROXY_CHROME_PORT_TO&quot;) || &quot;9223&quot; config :chroxy, Chroxy.ProxyListener, host: System.get_env(&quot;CHROXY_PROXY_HOST&quot;) || &quot;127.0.0.1&quot;, port: System.get_env(&quot;CHROXY_PROXY_PORT&quot;) || &quot;1331&quot; config :chroxy, Chroxy.ProxyServer, packet_trace: false config :chroxy, Chroxy.Endpoint, scheme: :http, port: System.get_env(&quot;CHROXY_ENDPOINT_PORT&quot;) || &quot;1330&quot; config :chroxy, Chroxy.ChromeServer, page_wait_ms: System.get_env(&quot;CHROXY_CHROME_SERVER_PAGE_WAIT_MS&quot;) || &quot;200&quot;, crash_dumps_dir: System.get_env(&quot;CHROME_CHROME_SERVER_CRASH_DUMPS_DIR&quot;) || &quot;/tmp&quot;, verbose_logging: 0 The only other configuration options in speed test is your base URL. config :speed_test, base_url: &quot;http://localhost:4003&quot;","ref":"usage.html#configuration","title":"Usage - Configuration","type":"extras"},{"doc":"In new tests I usually import speed test and then in the setup block load a new page and pass that into the test block i.e. defmodule MyAppTest do use ExUnit.Case, async: true import SpeedTest setup do page = launch() dimensions(page, %{width: 1920, height: 1080}) [page: page] end end Then use that to test against: describe &quot;Home page&quot; do test &quot;fills in login email&quot;, %{page: page} do goto(page, &quot;/&quot;) {:ok, email_input} = page |&gt; get(&quot;[data-test=login_email]&quot;) :ok = page |&gt; type(email_input, &quot;testing@test.com&quot;) assert &quot;testing@test.com&quot; == page |&gt; value(email_input) end end","ref":"usage.html#writing-tests","title":"Usage - Writing Tests","type":"extras"}]